///////////////////////////////////////////////
///This demo was created by Spunky_Girl////////
///Creation Date: 12/24/08/////////////////////
///I was Mizukouken Ketsu, don't worry/////////
///////////////////////////////////////////////

turf/Grass
	icon = 'Map.dmi'

world
	version = 11
	mob = /mob/Player


mob
	var
		Health = 10
		Strength = 5
		Defense = 3
		canAttack = TRUE

	Player
		icon = 'Player.dmi'
		Login()
			src.loc = locate(5,5,1)
			..()
			world<<"<center>[src] has joined the world!</center>"

	NPC
		Enemy
			icon = 'Enemy.dmi'
			Defense = 2
			density = 0

obj/AoE_FX/Darkness
	icon = 'Darkness.dmi'
	layer = MOB_LAYER+1
	New()
		spawn(50) del(src)

mob/proc/Execution(path,radius)
	for(var/turf/T in orange(radius,src))
		new path(T)
	for(var/mob/M in orange(radius,src))
		src.AoE_Damage(M,radius)

mob/proc/AoE_Damage(mob/M,radius)
	var/dmg = src.Strength - M.Defense
	dmg = dmg*(radius + 1 - get_dist(src,M))
	M.Health -= dmg
	src.Damage_Text(M,dmg,"Attack (AoE)")

mob/proc/Damage_Text(mob/M,dmg,atk)
	viewers(M)<<"<font color=silver>[M]</font> has taken <font color=red>[dmg]</font> damage from <font color=silver>[src]</font>'s <b>[atk]</b>!"

mob/Player/verb/AoE_Attack()
	set
		name = "Attack (AoE)"
		category = "Skills"
	if(!canAttack) return
	canAttack = FALSE
	Execution(/obj/AoE_FX/Darkness,3)
	spawn(50) canAttack = TRUE